summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorBernhard Voelker <mail@bernhard-voelker.de>2012-04-10 10:10:50 +0200
committerJim Meyering <meyering@redhat.com>2012-04-19 19:31:48 +0200
commitfdf0a4496725d476243149cdef8549328c86f561 (patch)
tree593b356192a94042020c0d2bd219887f69698494
parent26996738e453d98d68e8a03f6d9733b89f7cdcd6 (diff)
downloadcoreutils-fdf0a4496725d476243149cdef8549328c86f561.tar.xz
tests: factor out expensive "pairs" code of misc/stty
* tests/Makefile.am (TESTS): Add misc/stty-pairs. * tests/init.cfg (stty_reversible_init_): New function. (stty_reversible_query_): New function. * tests/misc/stty: Factor out expensive "pairs" code into new test. Use new stty_reversible_* functions instead of evaluating static REV_* variables. * tests/misc/stty-pairs: Add new test. Code added from misc/stty. Mark this as an expensive test. Skip 'parenb' and 'cread' options, as these tests are known to fail. Like in misc/stty, also use the new stty_reversible_* functions.
-rw-r--r--tests/Makefile.am1
-rw-r--r--tests/init.cfg27
-rwxr-xr-xtests/misc/stty42
-rwxr-xr-xtests/misc/stty-pairs63
4 files changed, 94 insertions, 39 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 6d4f18e4d..ce2366b58 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -275,6 +275,7 @@ TESTS = \
misc/stdbuf \
misc/stty \
misc/stty-invalid \
+ misc/stty-pairs \
misc/stty-row-col \
misc/su-fail \
misc/sum \
diff --git a/tests/init.cfg b/tests/init.cfg
index 7bcd512a3..2e43c162d 100644
--- a/tests/init.cfg
+++ b/tests/init.cfg
@@ -241,6 +241,33 @@ rwx_to_mode_()
echo "=$u$g$o"
}
+# Set the global variable stty_reversible_ to a space-separated list of the
+# reversible settings from stty.c. stty_reversible_ also starts and ends
+# with a space.
+stty_reversible_init_()
+{
+ # Pad start with one space for the first option to match in query function.
+ stty_reversible_=' '$(perl -lne '/^ *{"(.*?)",.*\bREV\b/ and print $1' \
+ $abs_top_srcdir/src/stty.c | tr '\n' ' ')
+ # Ensure that there are at least 62, i.e., so we're alerted if
+ # reformatting the source empties the list.
+ test 62 -le $(echo "$stty_reversible_"|wc -w) \
+ || framework_failure_ "too few reversible settings"
+}
+
+# Test whether $1 is one of stty's reversible options.
+stty_reversible_query_()
+{
+ case $stty_reversible_ in
+ '')
+ framework_failure_ "stty_reversible_init_() not called?";;
+ *" $1 "*)
+ return 0;;
+ *)
+ return 1;;
+ esac
+}
+
skip_if_()
{
case $1 in
diff --git a/tests/misc/stty b/tests/misc/stty
index cfc70c153..ae6565649 100755
--- a/tests/misc/stty
+++ b/tests/misc/stty
@@ -23,20 +23,8 @@ print_ver_ stty
require_controlling_input_terminal_
trap '' TTOU # Ignore SIGTTOU
-# The following list of reversible options was generated with
-# grep -w REV stty.c|sed -n '/^ {"/{s//REV_/;s/".*/=1/;p;}'|fmt
-REV_parenb=1 REV_parodd=1 REV_hupcl=1 REV_hup=1 REV_cstopb=1 REV_cread=1
-REV_clocal=1 REV_crtscts=1 REV_ignbrk=1 REV_brkint=1 REV_ignpar=1
-REV_parmrk=1 REV_inpck=1 REV_istrip=1 REV_inlcr=1 REV_igncr=1 REV_icrnl=1
-REV_ixon=1 REV_ixoff=1 REV_tandem=1 REV_iuclc=1 REV_ixany=1 REV_imaxbel=1
-REV_iutf8=1 REV_opost=1 REV_olcuc=1 REV_ocrnl=1 REV_onlcr=1 REV_onocr=1
-REV_onlret=1 REV_ofill=1 REV_ofdel=1 REV_isig=1 REV_icanon=1 REV_iexten=1
-REV_echo=1 REV_echoe=1 REV_crterase=1 REV_echok=1 REV_echonl=1
-REV_noflsh=1 REV_xcase=1 REV_tostop=1 REV_echoprt=1 REV_prterase=1
-REV_echoctl=1 REV_ctlecho=1 REV_echoke=1 REV_crtkill=1 REV_evenp=1
-REV_parity=1 REV_oddp=1 REV_nl=1 REV_cooked=1 REV_raw=1 REV_pass8=1
-REV_litout=1 REV_cbreak=1 REV_decctlq=1 REV_tabs=1 REV_lcase=1 REV_LCASE=1
-
+# Get the reversible settings from stty.c.
+stty_reversible_init_
saved_state=.saved-state
stty --save > $saved_state || fail=1
@@ -70,35 +58,11 @@ for opt in $options; do
# Likewise, 'stty -cread' would fail, so skip that, too.
test $opt = cread && continue
- eval rev=\$REV_$opt
- if test -n "$rev"; then
+ if stty_reversible_query_ "$opt" ; then
stty -$opt || { fail=1; echo -$opt; }
fi
done
-if test -n "$RUN_LONG_TESTS"; then
- # Take them in pairs.
- for opt1 in $options; do
- echo .|tr -d '\n'
- for opt2 in $options; do
-
- stty $opt1 $opt2 || fail=1
-
- eval rev1=\$REV_$opt1
- eval rev2=\$REV_$opt2
- if test -n "$rev1"; then
- stty -$opt1 $opt2 || fail=1
- fi
- if test -n "$rev2"; then
- stty $opt1 -$opt2 || fail=1
- fi
- if test "$rev1$rev2" = 11; then
- stty -$opt1 -$opt2 || fail=1
- fi
- done
- done
-fi
-
stty $(cat $saved_state)
Exit $fail
diff --git a/tests/misc/stty-pairs b/tests/misc/stty-pairs
new file mode 100755
index 000000000..e59da0435
--- /dev/null
+++ b/tests/misc/stty-pairs
@@ -0,0 +1,63 @@
+#!/bin/sh
+# Make sure stty can parse most of its options - in pairs [expensive].
+
+# Copyright (C) 1998-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ stty
+
+expensive_
+
+# Make sure there's a tty on stdin.
+require_controlling_input_terminal_
+trap '' TTOU # Ignore SIGTTOU
+
+# Get the reversible settings from stty.c.
+stty_reversible_init_
+
+saved_state=.saved-state
+stty --save > $saved_state || fail=1
+stty $(cat $saved_state) || fail=1
+
+# Build a list of all boolean options stty accepts on this system.
+# Don't depend on terminal width. Put each option on its own line,
+# remove all non-boolean ones, remove 'parenb' and 'cread' explicitly,
+# then remove any leading hyphens.
+sed_del='/^speed/d;/^rows/d;/^columns/d;/ = /d;s/parenb//;s/cread//'
+options=$(stty -a | tr -s ';' '\n' | sed "s/^ //;$sed_del;s/-//g")
+
+# Take them in pairs, with and without the leading '-'.
+for opt1 in $options; do
+ for opt2 in $options; do
+
+ stty $opt1 $opt2 || fail=1
+
+ if stty_reversible_query_ "$opt1" ; then
+ stty -$opt1 $opt2 || fail=1
+ fi
+ if stty_reversible_query_ "$opt2" ; then
+ stty $opt1 -$opt2 || fail=1
+ fi
+ if stty_reversible_query_ "$opt1" \
+ && stty_reversible_query_ "$opt2" ; then
+ stty -$opt1 -$opt2 || fail=1
+ fi
+ done
+done
+
+stty $(cat $saved_state)
+
+Exit $fail